#pragma once

#include <msclr/marshal.h>
#include <cliext/vector>
#include <cliext/algorithm>

#include "MyNativeData" 

namespace
{
  //! cv::Mat_<POD_TYPE> -> array<POD_TYPE>^
  template <typename POD_TYPE>
  inline array<POD_TYPE>^ marshal_helper(const cv::Mat_<POD_TYPE>& src)
  {
  }
} // private


//! System pre-defined name space 
namespace msclr 
{
  //! System pre-defined name space - we define additional marshaling for a few types here
  namespace interop 
  {
    //! std::vector<unsigned char> -> array<byte>
    template<>
    inline array<byte>^ marshal_as<array<byte>^, std::vector<unsigned char> >(const std::vector<unsigned char>& src)
    {
    }

    //! cv::Mat_<float> -> array<float>
    template<>
    inline array<float>^ marshal_as<array<float>^, cv::Mat_<float> >(const cv::Mat_<float>& src)
    {
    }
    
    //! cv::Mat_<ushort> -> array<ushort>
    template<>
    inline array<ushort>^ marshal_as<array<ushort>^, cv::Mat_<ushort> >(const cv::Mat_<ushort>& src)
    {
    }

    //! MyNativeData -> MyManagedData
    template<>
    inline MyManagedData^ 
      marshal_as<MyManagedData^, MyNativeData> 
      (const MyNativeData& src) 
    {
    }
  }
}  
